"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UPGRADE_REQUIRED = exports.TOO_EARLY = exports.FAILED_DEPENDENCY = exports.LOCKED = exports.UNPROCESSABLE_ENTITY = exports.MISDIRECTED_REQUEST = exports.METHOD_FAILURE = exports.INSUFFICIENT_SPACE_ON_RESOURCE = exports.IM_A_TEAPOT = exports.EXPECTATION_FAILED = exports.REQUESTED_RANGE_NOT_SATISFIABLE = exports.UNSUPPORTED_MEDIA_TYPE = exports.REQUEST_URI_TOO_LONG = exports.REQUEST_ENTITY_TOO_LARGE = exports.PRECONDITION_FAILED = exports.LENGTH_REQUIRED = exports.GONE = exports.CONFLICT = exports.REQUEST_TIMEOUT = exports.PROXY_AUTHENTICATION_REQUIRED = exports.NOT_ACCEPTABLE = exports.METHOD_NOT_ALLOWED = exports.NOT_FOUND = exports.FORBIDDEN = exports.PAYMENT_REQUIRED = exports.UNAUTHORIZED = exports.BAD_REQUEST = exports.PERMANENT_REDIRECT = exports.TEMPORARY_REDIRECT = exports.RESERVED = exports.USE_PROXY = exports.NOT_MODIFIED = exports.SEE_OTHER = exports.FOUND = exports.MOVED_PERMANENTLY = exports.MULTIPLE_CHOICES = exports.IM_USED = exports.ALREADY_REPORTED = exports.MULTI_STATUS = exports.PARTIAL_CONTENT = exports.RESET_CONTENT = exports.NO_CONTENT = exports.NON_AUTHORITATIVE_INFORMATION = exports.ACCEPTED = exports.CREATED = exports.OK = exports.EARLY_HINTS = exports.PROCESSING = exports.SWITCHING_PROTOCOLS = exports.CONTINUE = void 0;
exports.getStatusCode = exports.getStatusText = exports.NETWORK_AUTHENTICATION_REQUIRED = exports.NOT_EXTENDED = exports.LOOP_DETECTED = exports.INSUFFICIENT_STORAGE = exports.VARIANT_ALSO_NEGOTIATES_EXPERIMENTAL = exports.HTTP_VERSION_NOT_SUPPORTED = exports.GATEWAY_TIMEOUT = exports.SERVICE_UNAVAILABLE = exports.BAD_GATEWAY = exports.NOT_IMPLEMENTED = exports.INTERNAL_SERVER_ERROR = exports.UNAVAILABLE_FOR_LEGAL_REASONS = exports.REQUEST_HEADER_FIELDS_TOO_LARGE = exports.TOO_MANY_REQUESTS = exports.PRECONDITION_REQUIRED = void 0;
var httpCodes = {};
exports.CONTINUE = 100;
exports.SWITCHING_PROTOCOLS = 101;
exports.PROCESSING = 102;
exports.EARLY_HINTS = 103;
exports.OK = 200;
exports.CREATED = 201;
exports.ACCEPTED = 202;
exports.NON_AUTHORITATIVE_INFORMATION = 203;
exports.NO_CONTENT = 204;
exports.RESET_CONTENT = 205;
exports.PARTIAL_CONTENT = 206;
exports.MULTI_STATUS = 207;
exports.ALREADY_REPORTED = 208;
exports.IM_USED = 226;
exports.MULTIPLE_CHOICES = 300;
exports.MOVED_PERMANENTLY = 301;
exports.FOUND = 302;
exports.SEE_OTHER = 303;
exports.NOT_MODIFIED = 304;
exports.USE_PROXY = 305;
exports.RESERVED = 306;
exports.TEMPORARY_REDIRECT = 307;
exports.PERMANENT_REDIRECT = 308;
exports.BAD_REQUEST = 400;
exports.UNAUTHORIZED = 401;
exports.PAYMENT_REQUIRED = 402;
exports.FORBIDDEN = 403;
exports.NOT_FOUND = 404;
exports.METHOD_NOT_ALLOWED = 405;
exports.NOT_ACCEPTABLE = 406;
exports.PROXY_AUTHENTICATION_REQUIRED = 407;
exports.REQUEST_TIMEOUT = 408;
exports.CONFLICT = 409;
exports.GONE = 410;
exports.LENGTH_REQUIRED = 411;
exports.PRECONDITION_FAILED = 412;
exports.REQUEST_ENTITY_TOO_LARGE = 413;
exports.REQUEST_URI_TOO_LONG = 414;
exports.UNSUPPORTED_MEDIA_TYPE = 415;
exports.REQUESTED_RANGE_NOT_SATISFIABLE = 416;
exports.EXPECTATION_FAILED = 417;
exports.IM_A_TEAPOT = 418;
exports.INSUFFICIENT_SPACE_ON_RESOURCE = 419;
exports.METHOD_FAILURE = 420;
exports.MISDIRECTED_REQUEST = 421;
exports.UNPROCESSABLE_ENTITY = 422;
exports.LOCKED = 423;
exports.FAILED_DEPENDENCY = 424;
exports.TOO_EARLY = 425;
exports.UPGRADE_REQUIRED = 426;
exports.PRECONDITION_REQUIRED = 428;
exports.TOO_MANY_REQUESTS = 429;
exports.REQUEST_HEADER_FIELDS_TOO_LARGE = 431;
exports.UNAVAILABLE_FOR_LEGAL_REASONS = 451;
exports.INTERNAL_SERVER_ERROR = 500;
exports.NOT_IMPLEMENTED = 501;
exports.BAD_GATEWAY = 502;
exports.SERVICE_UNAVAILABLE = 503;
exports.GATEWAY_TIMEOUT = 504;
exports.HTTP_VERSION_NOT_SUPPORTED = 505;
exports.VARIANT_ALSO_NEGOTIATES_EXPERIMENTAL = 506;
exports.INSUFFICIENT_STORAGE = 507;
exports.LOOP_DETECTED = 508;
exports.NOT_EXTENDED = 510;
exports.NETWORK_AUTHENTICATION_REQUIRED = 511;
httpCodes[exports.CONTINUE] = "Continue";
httpCodes[exports.SWITCHING_PROTOCOLS] = "Switching Protocols";
httpCodes[exports.PROCESSING] = "Processing";
httpCodes[exports.EARLY_HINTS] = "Early Hints";
httpCodes[exports.OK] = "OK";
httpCodes[exports.CREATED] = "Created";
httpCodes[exports.ACCEPTED] = "Accepted";
httpCodes[exports.NON_AUTHORITATIVE_INFORMATION] = "Non Authoritative Information";
httpCodes[exports.NO_CONTENT] = "No Content";
httpCodes[exports.RESET_CONTENT] = "Reset Content";
httpCodes[exports.PARTIAL_CONTENT] = "Partial Content";
httpCodes[exports.MULTI_STATUS] = "Multi-Status";
httpCodes[exports.ALREADY_REPORTED] = "Already Reported";
httpCodes[exports.IM_USED] = "IM Used";
httpCodes[exports.MULTIPLE_CHOICES] = "Multiple Choices";
httpCodes[exports.MOVED_PERMANENTLY] = "Moved Permanently";
httpCodes[exports.FOUND] = "Found";
httpCodes[exports.SEE_OTHER] = "See Other";
httpCodes[exports.NOT_MODIFIED] = "Not Modified";
httpCodes[exports.USE_PROXY] = "Use Proxy";
httpCodes[exports.RESERVED] = "(Unused)";
httpCodes[exports.TEMPORARY_REDIRECT] = "Temporary Redirect";
httpCodes[exports.PERMANENT_REDIRECT] = "Permanent Redirect";
httpCodes[exports.BAD_REQUEST] = "Bad Request";
httpCodes[exports.UNAUTHORIZED] = "Unauthorized";
httpCodes[exports.PAYMENT_REQUIRED] = "Payment Required";
httpCodes[exports.FORBIDDEN] = "Forbidden";
httpCodes[exports.NOT_FOUND] = "Not Found";
httpCodes[exports.METHOD_NOT_ALLOWED] = "Method Not Allowed";
httpCodes[exports.NOT_ACCEPTABLE] = "Not Acceptable";
httpCodes[exports.PROXY_AUTHENTICATION_REQUIRED] = "Proxy Authentication Required";
httpCodes[exports.REQUEST_TIMEOUT] = "Request Timeout";
httpCodes[exports.CONFLICT] = "Conflict";
httpCodes[exports.GONE] = "Gone";
httpCodes[exports.LENGTH_REQUIRED] = "Length Required";
httpCodes[exports.PRECONDITION_FAILED] = "Precondition Failed";
httpCodes[exports.REQUEST_ENTITY_TOO_LARGE] = "Payload Too Large";
httpCodes[exports.REQUEST_URI_TOO_LONG] = "Request-URI Too Long";
httpCodes[exports.UNSUPPORTED_MEDIA_TYPE] = "Unsupported Media Type";
httpCodes[exports.REQUESTED_RANGE_NOT_SATISFIABLE] = "Requested Range Not Satisfiable";
httpCodes[exports.EXPECTATION_FAILED] = "Expectation Failed";
httpCodes[exports.IM_A_TEAPOT] = "I'm a teapot";
httpCodes[exports.INSUFFICIENT_SPACE_ON_RESOURCE] = "Insufficient Space on Resource";
httpCodes[exports.METHOD_FAILURE] = "Method Failure";
httpCodes[exports.MISDIRECTED_REQUEST] = "Misdirected Request";
httpCodes[exports.UNPROCESSABLE_ENTITY] = "Unprocessable Entity";
httpCodes[exports.LOCKED] = "Locked";
httpCodes[exports.FAILED_DEPENDENCY] = "Failed Dependency";
httpCodes[exports.TOO_EARLY] = "Too Early";
httpCodes[exports.UPGRADE_REQUIRED] = "Upgrade Required";
httpCodes[exports.PRECONDITION_REQUIRED] = "Precondition Required";
httpCodes[exports.TOO_MANY_REQUESTS] = "Too Many Requests";
httpCodes[exports.REQUEST_HEADER_FIELDS_TOO_LARGE] = "Request Header Fields Too Large";
httpCodes[exports.UNAVAILABLE_FOR_LEGAL_REASONS] = "Unavailable For Legal Reasons";
httpCodes[exports.INTERNAL_SERVER_ERROR] = "Internal Server Error";
httpCodes[exports.NOT_IMPLEMENTED] = "Not Implemented";
httpCodes[exports.BAD_GATEWAY] = "Bad Gateway";
httpCodes[exports.SERVICE_UNAVAILABLE] = "Service Unavailable";
httpCodes[exports.GATEWAY_TIMEOUT] = "Gateway Timeout";
httpCodes[exports.HTTP_VERSION_NOT_SUPPORTED] = "HTTP Version Not Supported";
httpCodes[exports.VARIANT_ALSO_NEGOTIATES_EXPERIMENTAL] = "Variant Also Negotiates";
httpCodes[exports.INSUFFICIENT_STORAGE] = "Insufficient Storage";
httpCodes[exports.LOOP_DETECTED] = "Loop Detected";
httpCodes[exports.NOT_EXTENDED] = "Not Extended";
httpCodes[exports.NETWORK_AUTHENTICATION_REQUIRED] = "Network Authentication Required";
var getStatusText = function (httpCode) {
    if (httpCodes.hasOwnProperty(httpCode)) {
        return httpCodes[httpCode];
    }
    else {
        throw new Error("Http status code does not exist: " + httpCode);
    }
};
exports.getStatusText = getStatusText;
var getStatusCode = function (reasonPhrase) {
    for (var key in httpCodes) {
        if (httpCodes[key] === reasonPhrase) {
            return parseInt(key, 10);
        }
    }
    throw new Error("Reason phrase does not exist: " + reasonPhrase);
};
exports.getStatusCode = getStatusCode;
