interface HttpCodes {
    [key: number]: string;
}

const httpCodes: HttpCodes = {};

export const CONTINUE = 100;
export const SWITCHING_PROTOCOLS = 101;
export const PROCESSING = 102;
export const EARLY_HINTS = 103;
export const OK = 200;
export const CREATED = 201;
export const ACCEPTED = 202;
export const NON_AUTHORITATIVE_INFORMATION = 203;
export const NO_CONTENT = 204;
export const RESET_CONTENT = 205;
export const PARTIAL_CONTENT = 206;
export const MULTI_STATUS = 207;
export const ALREADY_REPORTED = 208;
export const IM_USED = 226;
export const MULTIPLE_CHOICES = 300;
export const MOVED_PERMANENTLY = 301;
export const FOUND = 302;
export const SEE_OTHER = 303;
export const NOT_MODIFIED = 304;
export const USE_PROXY = 305;
export const RESERVED = 306;
export const TEMPORARY_REDIRECT = 307;
export const PERMANENT_REDIRECT = 308;
export const BAD_REQUEST = 400;
export const UNAUTHORIZED = 401;
export const PAYMENT_REQUIRED = 402;
export const FORBIDDEN = 403;
export const NOT_FOUND = 404;
export const METHOD_NOT_ALLOWED = 405;
export const NOT_ACCEPTABLE = 406;
export const PROXY_AUTHENTICATION_REQUIRED = 407;
export const REQUEST_TIMEOUT = 408;
export const CONFLICT = 409;
export const GONE = 410;
export const LENGTH_REQUIRED = 411;
export const PRECONDITION_FAILED = 412;
export const REQUEST_ENTITY_TOO_LARGE = 413;
export const REQUEST_URI_TOO_LONG = 414;
export const UNSUPPORTED_MEDIA_TYPE = 415;
export const REQUESTED_RANGE_NOT_SATISFIABLE = 416;
export const EXPECTATION_FAILED = 417;
export const IM_A_TEAPOT = 418;
export const INSUFFICIENT_SPACE_ON_RESOURCE = 419;
export const METHOD_FAILURE = 420;
export const MISDIRECTED_REQUEST = 421;
export const UNPROCESSABLE_ENTITY = 422;
export const LOCKED = 423;
export const FAILED_DEPENDENCY = 424;
export const TOO_EARLY = 425;
export const UPGRADE_REQUIRED = 426;
export const PRECONDITION_REQUIRED = 428;
export const TOO_MANY_REQUESTS = 429;
export const REQUEST_HEADER_FIELDS_TOO_LARGE = 431;
export const UNAVAILABLE_FOR_LEGAL_REASONS = 451;
export const INTERNAL_SERVER_ERROR = 500;
export const NOT_IMPLEMENTED = 501;
export const BAD_GATEWAY = 502;
export const SERVICE_UNAVAILABLE = 503;
export const GATEWAY_TIMEOUT = 504;
export const HTTP_VERSION_NOT_SUPPORTED = 505;
export const VARIANT_ALSO_NEGOTIATES_EXPERIMENTAL = 506;
export const INSUFFICIENT_STORAGE = 507;
export const LOOP_DETECTED = 508;
export const NOT_EXTENDED = 510;
export const NETWORK_AUTHENTICATION_REQUIRED = 511;

httpCodes[CONTINUE] = "Continue";
httpCodes[SWITCHING_PROTOCOLS] = "Switching Protocols";
httpCodes[PROCESSING] = "Processing";
httpCodes[EARLY_HINTS] = "Early Hints";
httpCodes[OK] = "OK";
httpCodes[CREATED] = "Created";
httpCodes[ACCEPTED] = "Accepted";
httpCodes[NON_AUTHORITATIVE_INFORMATION] = "Non Authoritative Information";
httpCodes[NO_CONTENT] = "No Content";
httpCodes[RESET_CONTENT] = "Reset Content";
httpCodes[PARTIAL_CONTENT] = "Partial Content";
httpCodes[MULTI_STATUS] = "Multi-Status";
httpCodes[ALREADY_REPORTED] = "Already Reported";
httpCodes[IM_USED] = "IM Used";
httpCodes[MULTIPLE_CHOICES] = "Multiple Choices";
httpCodes[MOVED_PERMANENTLY] = "Moved Permanently";
httpCodes[FOUND] = "Found";
httpCodes[SEE_OTHER] = "See Other";
httpCodes[NOT_MODIFIED] = "Not Modified";
httpCodes[USE_PROXY] = "Use Proxy";
httpCodes[RESERVED] = "(Unused)";
httpCodes[TEMPORARY_REDIRECT] = "Temporary Redirect";
httpCodes[PERMANENT_REDIRECT] = "Permanent Redirect";
httpCodes[BAD_REQUEST] = "Bad Request";
httpCodes[UNAUTHORIZED] = "Unauthorized";
httpCodes[PAYMENT_REQUIRED] = "Payment Required";
httpCodes[FORBIDDEN] = "Forbidden";
httpCodes[NOT_FOUND] = "Not Found";
httpCodes[METHOD_NOT_ALLOWED] = "Method Not Allowed";
httpCodes[NOT_ACCEPTABLE] = "Not Acceptable";
httpCodes[PROXY_AUTHENTICATION_REQUIRED] = "Proxy Authentication Required";
httpCodes[REQUEST_TIMEOUT] = "Request Timeout";
httpCodes[CONFLICT] = "Conflict";
httpCodes[GONE] = "Gone";
httpCodes[LENGTH_REQUIRED] = "Length Required";
httpCodes[PRECONDITION_FAILED] = "Precondition Failed";
httpCodes[REQUEST_ENTITY_TOO_LARGE] = "Payload Too Large";
httpCodes[REQUEST_URI_TOO_LONG] = "Request-URI Too Long";
httpCodes[UNSUPPORTED_MEDIA_TYPE] = "Unsupported Media Type";
httpCodes[REQUESTED_RANGE_NOT_SATISFIABLE] = "Requested Range Not Satisfiable";
httpCodes[EXPECTATION_FAILED] = "Expectation Failed";
httpCodes[IM_A_TEAPOT] = "I'm a teapot";
httpCodes[INSUFFICIENT_SPACE_ON_RESOURCE] = "Insufficient Space on Resource";
httpCodes[METHOD_FAILURE] = "Method Failure";
httpCodes[MISDIRECTED_REQUEST] = "Misdirected Request";
httpCodes[UNPROCESSABLE_ENTITY] = "Unprocessable Entity";
httpCodes[LOCKED] = "Locked";
httpCodes[FAILED_DEPENDENCY] = "Failed Dependency";
httpCodes[TOO_EARLY] = "Too Early";
httpCodes[UPGRADE_REQUIRED] = "Upgrade Required";
httpCodes[PRECONDITION_REQUIRED] = "Precondition Required";
httpCodes[TOO_MANY_REQUESTS] = "Too Many Requests";
httpCodes[REQUEST_HEADER_FIELDS_TOO_LARGE] = "Request Header Fields Too Large";
httpCodes[UNAVAILABLE_FOR_LEGAL_REASONS] = "Unavailable For Legal Reasons";
httpCodes[INTERNAL_SERVER_ERROR] = "Internal Server Error";
httpCodes[NOT_IMPLEMENTED] = "Not Implemented";
httpCodes[BAD_GATEWAY] = "Bad Gateway";
httpCodes[SERVICE_UNAVAILABLE] = "Service Unavailable";
httpCodes[GATEWAY_TIMEOUT] = "Gateway Timeout";
httpCodes[HTTP_VERSION_NOT_SUPPORTED] = "HTTP Version Not Supported";
httpCodes[VARIANT_ALSO_NEGOTIATES_EXPERIMENTAL] = "Variant Also Negotiates";
httpCodes[INSUFFICIENT_STORAGE] = "Insufficient Storage";
httpCodes[LOOP_DETECTED] = "Loop Detected";
httpCodes[NOT_EXTENDED] = "Not Extended";
httpCodes[NETWORK_AUTHENTICATION_REQUIRED] = "Network Authentication Required";

export const getStatusText = function (httpCode: number): string {
    if (httpCodes.hasOwnProperty(httpCode)) {
        return httpCodes[httpCode];
    } else {
        throw new Error("Http status code does not exist: " + httpCode);
    }
};

export const getStatusCode = function (reasonPhrase: string): number {
    for (const key in httpCodes) {
        if (httpCodes[key] === reasonPhrase) {
            return parseInt(key, 10);
        }
    }
    throw new Error("Reason phrase does not exist: " + reasonPhrase);
};
